<?php
namespace Teknisa\CMP\Modules\V1\Controllers; 

use Doctrine\DBAL\Connection;
use Zeedhi\Framework\DTO;


class AutoforneFilial extends \Teknisa\GER\Modules\V1\Controllers\TeknisaCrud {

    protected $dataSourceName = "autorizaFornecimento";
    protected $parameterBagColumns = array ("CDFILDEST", "CDFILLANC", "CDFORNECED", "CDCOMPRADOR", "NRORG", "IDBAIXAAF","IDBAIXAAF_NULOS", "IDAFFORALIM", "IDSITUATUAAF", "DTPROGENTAF_INI", "DTPROGENTAF_FIN", "DTAUTOFORN_INI", "DTAUTOFORN_FIN", "DTPROGENTAF");
    protected $novoCodigo;
    protected $environment;
    protected $autoforne;
    protected $connection;

    public function __construct ($novoCodigo, $dataSourceManager, $environment, $parameterBag, $connection) {

        $this->novoCodigo = $novoCodigo;
        $this->environment = $environment;
        $this->connection = $connection;
        parent::__construct($dataSourceManager, $environment, $parameterBag);

   }


    private function insereJustificativa($row, $request, $response){

        $this->autoforne = $this->novoCodigo->getCodeByTableName('AUTOFORNE'.$row['rowAF']['CDFILDEST'].$row['rowAF']['CDFILLANC'], $row['rowAF']['NRORG']);

        $row['rowJustificativa']['NRAUTOMOV'] = $this->autoforne;

        $this->dataSourceName = 'movopaf';

            $parametros = array(
                "NRORG" => $this->environment->getNrOrg(),
                "CDFILDESMOV"    => $row['rowJustificativa']['CDFILDESMOV'],
                "CDFILLANMOV"    => $row['rowJustificativa']['CDFILLANMOV'],
                "NRAUTOMOV"      => $row['rowJustificativa']['NRAUTOMOV'],
                "DTPROGENTMOV"   => $row['rowJustificativa']['DTPROGENTMOV'],
                "IDOPERAMOVAF"   => $row['rowJustificativa']['IDOPERAMOVAF'],
                "DSALTERAF"      => $row['rowJustificativa']['DSALTERAF'],
                "DSJUSTOPERMOV"  => $row['rowJustificativa']['DSJUSTOPERMOV'],
                "DSOUTRAJUST"    => $row['rowJustificativa']['DSOUTRAJUST'],
                "DTINCLUSAO"     => $row['rowJustificativa']['DTINCLUSAO'],
                "CDOPERINCLUSAO" => $row['rowJustificativa']['CDOPERINCLUSAO'],
                "DTULTATU"       => $row['rowJustificativa']['DTULTATU'],
                "NRORGINCLUSAO"  => $row['rowJustificativa']['NRORGINCLUSAO'],
                "CDOPERULTATU"   => $row['rowJustificativa']['CDOPERULTATU'],
                "NRORGULTATU"    => $row['rowJustificativa']['NRORGULTATU'],
                "IDATIVO"        => $row['rowJustificativa']['IDATIVO'],
                "CDOPERADOR"     => $row['rowJustificativa']['CDOPERADOR'],
                "changed"        => false,
                "__is_new"       => true
            );
            $newRequest = new DTO\Request\Row($parametros, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
            $this->save($newRequest, $response);

    }

    private function insereAF($row, $request, $response){

        $row['rowAF']['NRAUTOFORN'] = $this->autoforne;

        $this->dataSourceName = 'autorizaFornecimento';

        $parametros = array(
            "NRORG"          => $this->environment->getNrOrg(),
            "CDFILDEST"      => $row['rowAF']['CDFILDEST'],
            "CDFILLANC"      => $row['rowAF']['CDFILLANC'],
            "NRAUTOFORN"     => $row['rowAF']['NRAUTOFORN'],
            "DTAUTOFORN"     => $row['rowAF']['DTAUTOFORN'],
            "IDAUTOFORNEX"   => $row['rowAF']['IDAUTOFORNEX'],
            "IDBAIXAAF"      => $row['rowAF']['IDBAIXAAF'],
            "IDSITUATUAAF"   => $row['rowAF']['IDSITUATUAAF'],
            "IDAFFORALIM"    => $row['rowAF']['IDAFFORALIM'],
            "VRTOTALAF"      => $row['rowAF']['VRTOTALAF'],
            "CDFORNECED"     => $row['rowAF']['CDFORNECED'],
            "NRINSJURTRAN"   => $row['rowAF']['NRINSJURTRAN'],
            "IDTIPOLANCAF"   => $row['rowAF']['IDTIPOLANCAF'],
            "VRTOTALAFORG"   => $row['rowAF']['VRTOTALAFORG'],
            "DTPROGENTAF"    => $row['rowAF']['DTPROGENTAF'],
            "CDEMPRESA"      => $row['rowAF']['CDEMPRESA'],
            "IDTIPOEMITAF"   => $row['rowAF']['IDTIPOEMITAF'],
            "IDAFOPERLOG"    => $row['rowAF']['IDAFOPERLOG'],
            "IDAFPILOTO"     => $row['rowAF']['IDAFPILOTO'],
            "IDTIPOFRETAF"   => $row['rowAF']['IDTIPOFRETAF'],
            "CDTIPCOB"       => $row['rowAF']['CDTIPCOB'],
            "DTINCLUSAO"     => $row['rowAF']['DTINCLUSAO'],
            "CDOPERINCLUSAO" => $row['rowAF']['CDOPERINCLUSAO'],
            "DTULTATU"       => $row['rowAF']['DTULTATU'],
            "NRORGINCLUSAO"  => $row['rowAF']['NRORGINCLUSAO'],
            "CDOPERULTATU"   => $row['rowAF']['CDOPERULTATU'],
            "NRORGULTATU"    => $row['rowAF']['NRORGULTATU'],
            "IDATIVO"        => $row['rowAF']['IDATIVO'],
            "CDOPERADOR"     => $row['rowAF']['CDOPERADOR'],
            "changed"        => false,
            "__is_new"       => true
        );
        $newRequest = new DTO\Request\Row($parametros, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
        $this->save($newRequest, $response);

    }

    private function insereProduto($row,$request, $response) {

        $this->dataSourceName = 'af_produtos';

        $row['rowAF']['NRAUTOFORN'] = $this->autoforne;

        $this->dataSourceName = 'af_produtos';

        $parametros = array(
            "NRORG"          => $this->environment->getNrOrg(),
            "CDFILDEST"      => $row['rowAF']['CDFILDEST'],
            "CDFILLANC"      => $row['rowAF']['CDFILLANC'],
            "NRAUTOFORN"     => $row['rowAF']['NRAUTOFORN'],
            "CDPRODUTO"      => $row['rowAF']['CDPRODUTO'],
            "CDMARCA"        => $row['rowAF']['CDMARCA'],
            "QTPROGENTAF"    => $row['rowAF']['IDSITUATUAAF'],
            "DTPROGENTAF"    => $row['rowAF']['DTPROGENTAFPROD'],
            "VRPREUNIAF"     => $row['rowAF']['VRPREUNIAF'],
            "CDFORNECED"     => $row['rowAF']['CDFORNECED'],
            "DTINCLUSAO"     => $row['rowAF']['DTINCLUSAO'],
            "CDOPERINCLUSAO" => $row['rowAF']['CDOPERINCLUSAO'],
            "DTULTATU"       => $row['rowAF']['DTULTATU'],
            "NRORGINCLUSAO"  => $row['rowAF']['NRORGINCLUSAO'],
            "CDOPERULTATU"   => $row['rowAF']['CDOPERULTATU'],
            "NRORGULTATU"    => $row['rowAF']['NRORGULTATU'],
            "IDATIVO"        => $row['rowAF']['IDATIVO'],
            "CDOPERADOR"     => $row['rowAF']['CDOPERADOR'],
            "changed"        => false,
            "__is_new"       => true
        );
        $newRequest = new DTO\Request\Row($parametros, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
        $this->save($newRequest, $response);


    }


    public function salvarAFJustificativa(DTO\Request\Row $request, DTO\Response $response){


        try{
            $this->connection->beginTransaction();

            $row = $request->getRow();

            $this->insereJustificativa($row, $request, $response);

            $this->insereAF($row, $request, $response);

            $this->insereProduto($row, $request, $response);

            $this->connection->commit();

        }catch (\Exception $e){
            $this->rollback();
        }

    }

    public function salvarAF(DTO\Request\Row $request, DTO\Response $response){


        try{
            $this->connection->beginTransaction();

            $row = $request->getRow();

            $this->autoforne = $this->novoCodigo->getCodeByTableName('AUTOFORNE'.$row['rowAF']['CDFILDEST'].$row['rowAF']['CDFILLANC'], $row['rowAF']['NRORG']);

            $this->insereAF($row, $request, $response);

            $this->insereProduto($row, $request, $response);

            $this->connection->commit();

        }catch (\Exception $e){
            $this->rollback();
        }

    }



    public function savejoao (DTO\Request\Row $request, DTO\Response $response) {

        $row = $request->getRow();

        $row['NRAUTOFORN'] = $this->novoCodigo->getCodeByTableName('AUTOFORNE'.$row['CDFILDEST'].$row['CDFILLANC'], $row['NRORG']);

        $this->dataSourceName = 'autorizaFornecimento';
        $this->save($request, $response);
    }

    public function geraNovoCodigo() {

    }

}