<?php
namespace Teknisa\CMP\Modules\V1\Controllers; 

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class Cmp03000 extends \Zeedhi\Framework\Controller\Report {
    
    protected $entityManager;
    protected $qr2Strategy;
    protected $stNomeRel;

    public function __construct($reportService, $entityManager, $qr2Strategy) {
        
        $this->entityManager       = $entityManager;
        $this->qr2Strategy         = $qr2Strategy;
        $this->reportService       = $reportService;

    }
    /** @var array  */
    protected $reportMapping = array ();
     public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response)
    {
        $row = $request->getRow();
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
        $this->stNomeRel = $this->getReportName($row);
        $this->reportMapping[$this->stNomeRel] =
            array (
                'strategy' => $row['STRATEGY'],
                'parameterMapping' =>
                    array (
                        'CDFILIAL' => 'L_CDFILIAL',
                        'CDFILIAL2' => 'L_CDFILIAL2',
                        'CDGRUPFILI' => 'P_CDGRUPFILI',
                        'CDOPERADOR' => 'L_CDOPERADOR',
                        'DTINI' => 'P_DTINI',
                        'DTFIN' => 'P_DTFIN',
                        'DTENTRINICIAL' => 'P_DTENTRINICIAL',
                        'DTENTRFINAL' => 'P_DTENTRFINAL'
                    ),
            );
    }

}